// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//          2006/03/15      FVC05Ή@K.Yakushinji
//-------------------------------------------------------------------
// Video2chDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "Video2ch.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"
#include "Video2chDlg.h"

#define TIMER_ID_GRAB 1		

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideo2chDlg _CAO

CVideo2chDlg::CVideo2chDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVideo2chDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVideo2chDlg)
	m_ascope = FALSE;
	m_offset = 0;
	m_exposure = 5;
	m_binlevel = 128;
	m_imagetype = -1;
	m_trigger = -1;
	m_channel = -1;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVideo2chDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVideo2chDlg)
	DDX_Control(pDX, IDC_SLDBINLEVEL, m_sldbinlevel);
	DDX_Control(pDX, IDC_SLDEXPOSURE, m_sldexposure);
	DDX_Control(pDX, IDC_SLDOFFSET, m_sldoffset);
	DDX_Check(pDX, IDC_ASCOPE, m_ascope);
	DDX_Text(pDX, IDC_OFFSET, m_offset);
	DDV_MinMaxInt(pDX, m_offset, -512, 511);
	DDX_Text(pDX, IDC_EXPOSURE, m_exposure);
	DDV_MinMaxInt(pDX, m_exposure, 0, 250);
	DDX_Text(pDX, IDC_BINLEVEL, m_binlevel);
	DDV_MinMaxInt(pDX, m_binlevel, 0, 255);
	DDX_CBIndex(pDX, IDC_IMAGETYPE, m_imagetype);
	DDX_CBIndex(pDX, IDC_TRIGGER, m_trigger);
	DDX_CBIndex(pDX, IDC_CHANNEL, m_channel);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVideo2chDlg, CDialog)
	//{{AFX_MSG_MAP(CVideo2chDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ASCOPE, OnAscope)
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_DISPMINUS, OnDispminus)
	ON_BN_CLICKED(IDC_DISPPLUS, OnDispplus)
	ON_BN_CLICKED(IDC_DISP1, OnDisp1)
	ON_BN_CLICKED(IDC_DISPFULL, OnDispfull)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_FREERUN, OnFreerun)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RESETVIDEOCONFFILE, OnResetvideoconffile)
	ON_CBN_SELCHANGE(IDC_CHANNEL, OnSelchangeChannel)
	ON_CBN_SELCHANGE(IDC_TRIGGER, OnSelchangeTrigger)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_CBN_SELCHANGE(IDC_IMAGETYPE, OnSelchangeImagetype)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideo2chDlg bZ[W nh

BOOL CVideo2chDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx1);

		pwnd = GetDlgItem(IDC_FVXDISPLAYEX2);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx2);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		
		// rfIfoCX̃I[vԕێϐ̏
		m_blnVideoOpened = false;
		GetDlgItem(IDC_GRAB)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREERUN)->EnableWindow(FALSE);

		// XC_[Rg[̏
		m_sldoffset.SetRange(-128,127,FALSE);
		m_sldoffset.SetTicFreq(32);
		m_sldexposure.SetRange(1,250,FALSE);
		m_sldexposure.SetTicFreq(10);
		m_sldbinlevel.SetRange(0,255,FALSE);
		m_sldbinlevel.SetTicFreq(32);

		m_sldoffset.SetPos(m_offset);
		m_sldexposure.SetPos(m_exposure);
		m_sldbinlevel.SetPos(m_binlevel);

		// fBXvC̏
		m_FvxDisplayEx1->CreateDisplay(1,0);
		m_FvxDisplayEx2->CreateDisplay(1,0);

		// rfIfoCXI
		setVideoConfFile();

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CVideo2chDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CVideo2chDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CVideo2chDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// AScope\؂ւ
void CVideo2chDlg::OnAscope() 
{
	if ( !UpdateData(TRUE) ) return;

	if (m_ascope) {
		m_FvxDisplayEx1->PutAScopeMode( DISPLAYEX_AScopeAuto );
		m_FvxDisplayEx2->PutAScopeMode( DISPLAYEX_AScopeAuto );
	} else {
		m_FvxDisplayEx1->PutAScopeMode( DISPLAYEX_AScopeDisable );
		m_FvxDisplayEx2->PutAScopeMode( DISPLAYEX_AScopeDisable );
	}
	
}

// rfIfoCXI
void CVideo2chDlg::setVideoConfFile()
{

    long lngCaptureType = 0;			// Lv`{[h̃^Cv(0=RICE/1=FVC01/2=FVC02)
    long lngCaptureNum = 0;				// Lv`{[h̖
    long lngCaptureConnectorNum = 0;	//P{[h̃RlN^
    long lngBinMode = 0;
	long err_no = 0;
	long i=0 , j=0;
	CString str;

	CConfFileDlg fdlg;
    
    if ( m_blnVideoOpened ) {
        // rfIfoCXI[vĂꍇ͈UN[Y܂
        m_FvxVideo->CloseDevice();
        m_blnVideoOpened = false;
		GetDlgItem(IDC_GRAB)->EnableWindow( FALSE );
		GetDlgItem(IDC_FREERUN)->EnableWindow( FALSE );
	}

	// rfIݒt@C̑I
	fdlg.DoModal();

	if (fdlg.m_conffile.GetLength() != 0) {
	
		
		// rfIݒt@CR|[lgɐݒ
 		m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

		// rfIfoCXI[v
		try {

			m_FvxVideo->OpenDevice();

		} catch( _com_error ) {
		
			m_FvxVideo->GetErrReport( &err_no );
			MessageBox("rfIfoCX̃I[vɎs܂" , "G[" , MB_ICONWARNING | MB_OK );
			return;
		}

		// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
		// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
		// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
		// g̃Lv`{[hɍ킹ĕύXĂB
		::Sleep(350);
		try	{

			// 2ch荞
			m_FvxVideo->GetSimGrab( &i );
			if ( i != 2  ) {
				m_FvxVideo->SetSimGrab( 2 ) ;
			}

		} catch(_com_error ) {
		
			m_FvxVideo->GetErrReport( &err_no );
			MessageBox("荞݂̐ݒɎs܂" , "G[" , MB_ICONWARNING | MB_OK );
			return ;
		}
			
		// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
		// 炩ChangeImageSize\bhɂImagẽTCYύXĂ
		// i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
		m_FvxVideo->ChangeImageSize(m_FvxImage1);

		try	{

			// 捞
			m_FvxVideo->GrabSync(m_FvxImage1);

		} catch(_com_error ) {
		
			m_FvxVideo->GetErrReport( &err_no );
			MessageBox("rfI̎捞Ɏs܂" , "G[" , MB_ICONWARNING | MB_OK );
			return ;

		}

		// J荞ݗL
		GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->EnableWindow(TRUE);
		// rfIfoCX̏ԂL
		m_blnVideoOpened = true;

		// Lv`{[h擾
		m_FvxVideo->GetCaptureNum( &lngCaptureNum );

		// Lv`{[h^Cv擾
		m_FvxVideo->GetCaptureType( &lngCaptureType );
    
		// Lv`{[hPchݒ
		switch ( lngCaptureType ) {
			case 1: 
				// RICE001
				lngCaptureConnectorNum = 4;
				break;
			case 2: 
				// FVC01
				lngCaptureConnectorNum = 2;
				break;
			case 3: 
				// FVC02
				lngCaptureConnectorNum = 2;
				break;
			case 6: 
				// FV1100
				lngCaptureConnectorNum = 4;
				break;
			case 7: 
				// FVC05
				lngCaptureConnectorNum = 2;
				break;
			default:
				lngCaptureConnectorNum = 0;
				break;
		}
			
		// `l
		// gpłch 0`((I[vĂ{[h)*({[h̃J̓RlN^)-1) ł
		// Rg[ނ̏
		CComboBox*    pcmb;

		pcmb = ( CComboBox* )GetDlgItem( IDC_CHANNEL );
		pcmb->ResetContent();
		for ( i = 0; i < ( lngCaptureNum * lngCaptureConnectorNum ) / 2 ; i++ ) {
			str.Format("CH%d-%d",i*2,i*2+1);					
			pcmb->AddString( str );
		}

		m_channel = 0;
    
		// gK[h
		pcmb = ( CComboBox* )GetDlgItem( IDC_TRIGGER );
		pcmb->ResetContent();
		pcmb->AddString( "m[}" );
		pcmb->AddString( "gK(SW)" );

		// RICE(CaptureType=1)͊OgKgps
		if ( lngCaptureType >= 2 ) {                
			pcmb->AddString( "OgK(Ext)" );
		}
		m_trigger = 0 ;

		// 捞摜
		pcmb = ( CComboBox* )GetDlgItem( IDC_IMAGETYPE );
		pcmb->ResetContent();
		pcmb->AddString( "" );
		pcmb->AddString( "1f1bit2l" );
		pcmb->AddString( "1f8bit2l(0/255)" );
		pcmb->AddString( "1f8bit臒lȏ255" );
    
		// RICE(CaptureType=1)͘IԐݒEHWQls\
		if ( lngCaptureType < 2 ) {

			m_blnCanHWBinarize = false;
       		GetDlgItem(IDC_IMAGETYPE)->EnableWindow(FALSE);
       		GetDlgItem(IDC_BINLEVEL)->EnableWindow(FALSE);
       		GetDlgItem(IDC_SLDBINLEVEL)->EnableWindow(FALSE);
       		GetDlgItem(IDC_EXPOSURE)->EnableWindow(FALSE);
       		GetDlgItem(IDC_SLDEXPOSURE)->EnableWindow(FALSE);

		} else {
	
			m_imagetype = 0;
			
			m_blnCanHWBinarize = true;
       		GetDlgItem(IDC_IMAGETYPE)->EnableWindow(TRUE);
			// HWQl
			m_FvxVideo->GetBinarizeThreshold( &i );
			m_sldbinlevel.SetPos( i );
			m_binlevel = i;
       		GetDlgItem(IDC_SLDBINLEVEL)->EnableWindow(TRUE);
       		GetDlgItem(IDC_BINLEVEL)->EnableWindow(TRUE);

			// I
			m_FvxVideo->GetExposureTime( &i );
			m_sldexposure.SetPos(  i / 1000 );
			m_exposure = (i / 1000);
       		GetDlgItem(IDC_SLDEXPOSURE)->EnableWindow(TRUE);
       		GetDlgItem(IDC_EXPOSURE)->EnableWindow(TRUE);
        
			if (( lngCaptureType == 6 ) || ( lngCaptureType == 7 )) {
				// 捞摜
				pcmb = ( CComboBox* )GetDlgItem( IDC_IMAGETYPE );
				pcmb->ResetContent();
				pcmb->AddString( "" );
				pcmb->AddString( "1f1bit2l" );
			}
		}

		// rfIItZbg
		m_FvxVideo->GetVideoOffset( &i );
		m_sldoffset.SetPos( i );
		m_offset = i;
    
		// FV1100̂݃rfIItZbg-512`511
		if (( lngCaptureType == 6 ) || ( lngCaptureType == 7 )){
			m_sldoffset.SetRange(-512,511,FALSE);
			GetDlgItem( IDC_OFFSETMIN )->SetWindowText("-512");
			GetDlgItem( IDC_OFFSETMAX )->SetWindowText("511");
		}
	}
	
	// 摜̕\
	m_FvxDisplayEx1->DrawImage(m_FvxImage1);
    m_FvxImage1->PutCurrentNo( 1 );
	m_FvxDisplayEx2->DrawImage(m_FvxImage1);
    m_FvxImage1->PutCurrentNo( 0 );

	UpdateData(FALSE);

}

void CVideo2chDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}

}

BOOL CVideo2chDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CVideo2chDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx1 != NULL ){

			CWnd *pwnd;
			CRect rect1,rect2;

			// FvxDisplayEx1̃TCYύX
			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect1 );

			ScreenToClient( rect1 );
			pwnd->MoveWindow( rect1.left , rect1.top, cx - (rect1.left + 20) , (cy / 2 ) - 20   , TRUE );

			// FvxDisplayEx2̃TCYύX
			pwnd = GetDlgItem( IDC_FVXDISPLAYEX2 );
			pwnd->GetWindowRect( rect2 );

			ScreenToClient( rect2 );
			pwnd->MoveWindow( rect1.left , (cy / 2 ), cx - (rect1.left + 20) , (cy / 2 ) - 20 , TRUE );
		}
	}

}

// \{minus
void CVideo2chDlg::OnDispminus() 
{

	m_FvxDisplayEx1->PutMagnification( m_FvxDisplayEx1->GetMagnification() - 0.5 );
	m_FvxDisplayEx2->PutMagnification( m_FvxDisplayEx1->GetMagnification() );
    if ( m_FvxDisplayEx1->GetMagnification()  <= 0.5   ) {
		GetDlgItem(IDC_DISPMINUS)->EnableWindow( FALSE );
    } else {
		GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );
	}
	GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );	

}

// \{plus
void CVideo2chDlg::OnDispplus() 
{
	m_FvxDisplayEx1->PutMagnification( m_FvxDisplayEx1->GetMagnification() + 0.5 );
	m_FvxDisplayEx2->PutMagnification( m_FvxDisplayEx1->GetMagnification() );
	if ( m_FvxDisplayEx1->GetMagnification() > 10) {
		GetDlgItem(IDC_DISPPLUS)->EnableWindow( FALSE );	
    } else {
		GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );	
	}
	GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );
	
}

// {\
void CVideo2chDlg::OnDisp1() 
{
	m_FvxDisplayEx1->PutMagnification( 1 );
	m_FvxDisplayEx2->PutMagnification( 1 );
    
	GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );	
	GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );	
}

// tʕ\
void CVideo2chDlg::OnDispfull() 
{
	CRect rect;

	GetDlgItem( IDC_FVXDISPLAYEX1 )->GetWindowRect( rect );

	// XN[WNCAgWɕϊ
	ScreenToClient( rect );

    double dblScaleX = ( (double)( rect.right - rect.left )) / m_FvxImage1->GetImageWidth();
    double dblScaleY = ( (double)( rect.bottom - rect.top )) / m_FvxImage1->GetImageHeight();
   

	if ( dblScaleX < dblScaleY ) {
        m_FvxDisplayEx1->PutMagnification( dblScaleX );
        m_FvxDisplayEx2->PutMagnification( dblScaleX );
    } else {
        m_FvxDisplayEx1->PutMagnification( dblScaleY );
        m_FvxDisplayEx2->PutMagnification( dblScaleY );
	}
			
	GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );
	GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );	
	
}

// 荞
void CVideo2chDlg::OnGrab() 
{

	CString str;

    m_FvxPerformanceCounter->StartCount();		// ԑJn
    
	try {
		// 捞
		m_FvxVideo->GrabSync( m_FvxImage1 );
	} catch (_com_error) {

	    long lngErr = 0;
		m_FvxVideo->GetErrReport( &lngErr );
		
		str.Format("捞G[ ( %d,)",lngErr);
		if (lngErr != 0) {
			MessageBox(str, "G[" , MB_ICONWARNING | MB_OK );
		}
	}

    double dblTime = 0;
	m_FvxPerformanceCounter->StopCount( &dblTime );   // ԑI
    
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx1->DrawImage( m_FvxImage1 );
    m_FvxImage1->PutCurrentNo( 1 );
    m_FvxDisplayEx2->DrawImage( m_FvxImage1 );
    m_FvxImage1->PutCurrentNo( 0 );
    
    str.Format("%.2fms",dblTime);
	GetDlgItem(IDC_GRABTIME)->SetWindowText( str );	

}

// t[iA荞݁jstart/stop
void CVideo2chDlg::OnFreerun() 
{
    if ( m_intIsFreerun == 1 ) {
		GetDlgItem( IDC_GRAB )->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Freerun");
		KillTimer( TIMER_ID_GRAB );
		m_intIsFreerun = 0;
	} else {
		SetTimer( TIMER_ID_GRAB, 50, NULL );
		GetDlgItem( IDC_GRAB )->EnableWindow(FALSE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Stop");
		m_intIsFreerun = 1;
	}
	
}

void CVideo2chDlg::OnTimer(UINT nIDEvent) 
{

	switch( nIDEvent ){
	case TIMER_ID_GRAB:

		if ( m_blnVideoOpened ) {

			try {
				// ԑJn
				m_FvxPerformanceCounter->StartCount();   
				// 捞
				m_FvxVideo->GrabSync( m_FvxImage1 );
				// ԑI
				double dblTime = 0;
				m_FvxPerformanceCounter->StopCount( &dblTime );
				// 摜\
				m_FvxDisplayEx1->DrawImage( m_FvxImage1 );
				m_FvxImage1->PutCurrentNo( 1 );
				m_FvxDisplayEx2->DrawImage( m_FvxImage1 );
				m_FvxImage1->PutCurrentNo( 0 );
				CString szTmp;
				szTmp.Format("%.2fms",dblTime);
				GetDlgItem(IDC_GRABTIME)->SetWindowText(szTmp);
			} catch( _com_error ) {
				long err_no=0;
				CString szErr;
				m_FvxVideo->GetErrReport( &err_no );
				szErr.Format("捞G[( %d )",err_no);
				MessageBox(szErr, "G[" , MB_ICONWARNING | MB_OK );
				KillTimer( TIMER_ID_GRAB );
				m_intIsFreerun = 0;
				return;
			}
		}
	}

	CDialog::OnTimer(nIDEvent);
}

// rfIݒt@CĐݒ
void CVideo2chDlg::OnResetvideoconffile() 
{
	// t[Ȃ΁A~B
    if ( m_intIsFreerun == 1 ) {
		GetDlgItem( IDC_GRAB )->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Freerun");
		KillTimer( TIMER_ID_GRAB );
		m_intIsFreerun = 0;
	}
    
    // rfIfoCX̑I
    setVideoConfFile();
	
}

// rfI`l
void CVideo2chDlg::OnSelchangeChannel() 
{
    if (!UpdateData(TRUE)) return;
	if ( m_blnVideoOpened ) {
        m_FvxVideo->SetChannel(  m_channel * 2);
	}
}

// gK[h
void CVideo2chDlg::OnSelchangeTrigger() 
{
    if (!UpdateData(TRUE)) return;
    if ( m_blnVideoOpened ) {
		try {
	        m_FvxVideo->SetTrigger( m_trigger );

		} catch ( _com_error) {
	        
			long lngErr = 0;
			CString cStr;

			m_FvxVideo->GetErrReport(&lngErr);
			cStr.Format("gK[[h̕ύX͂ł܂ł %d",lngErr);
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);

		}
	}	
	
}

void CVideo2chDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CString str;

	if( pScrollBar == (CScrollBar*)&m_sldoffset){
		str.Format("%d",m_sldoffset.GetPos());
		GetDlgItem(IDC_OFFSET)->SetWindowText(str);
		if ( m_blnVideoOpened ) {
			m_FvxVideo->SetVideoOffset( m_sldoffset.GetPos());
		}
    }
    else if(pScrollBar == (CScrollBar*)&m_sldexposure){
		str.Format("%d",m_sldexposure.GetPos());
		GetDlgItem(IDC_EXPOSURE)->SetWindowText(str);
		if ( m_blnVideoOpened ) {
			m_FvxVideo->SetExposureTime( m_sldexposure.GetPos()* 1000);
		}
    }
    else if(pScrollBar == (CScrollBar*)&m_sldbinlevel){
		str.Format("%d",m_sldbinlevel.GetPos());
		GetDlgItem(IDC_BINLEVEL)->SetWindowText(str);
		if ( m_blnVideoOpened  &&  m_blnCanHWBinarize ) {
		    m_FvxVideo->SetBinarizeTheshold( m_sldbinlevel.GetPos() );
		}
	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

// 摜̕ۑ
void CVideo2chDlg::OnSaveimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
	
}

// HWQlon/off
void CVideo2chDlg::OnSelchangeImagetype() 
{
	if (!UpdateData(TRUE)) return;

	if ( m_blnVideoOpened ) {
        m_FvxVideo->SetBinarizeMode( m_imagetype );
        m_FvxVideo->ChangeImageSize( m_FvxImage1 );
	}	
}
